/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package cz.muni.fi.pb162.computer.components;

/**
 *
 * @author apple
 */
public class MotherBoard extends Device{

    private Component[] usbDevices;
    private Component[] cards;
    private int usbDevicesNumber=0;
    private int cardsNumber=0;

    public MotherBoard(String id, int cards, int usbs) {
	super(id);
	this.cards = new Card[cards];
	this.usbDevices = new USBDevice[usbs];	
    }

    public boolean hasChildern(){
	return usbDevicesNumber >0 || cardsNumber > 0;
    }

    public Component[] getChildern(){
	Component[] devices = new Component[usbDevicesNumber+cardsNumber];
	int i = 0;

	for( ; i < cardsNumber ; i++){
		devices[i] = cards[i];
	}

	for(int j = 0; j < usbDevicesNumber; j++ , i++){
		devices[i] = usbDevices[j];
	}

	return devices;
    }

    public boolean isHub(){
	return usbDevices.length > 0;
    }

    public int getFreeSlots(){
	return cards.length - cardsNumber;
    }

    public int getFreePorts(){
	return usbDevices.length - usbDevicesNumber;
    }
    
    public boolean addComponent(Component device, ConnectionType where){
	boolean added = false;

	if(where == ConnectionType.USB){
		if(getFreePorts() > 0){
			usbDevices[usbDevicesNumber] = device;
			usbDevicesNumber ++;
			added = true;
		}
	} else {
		if(getFreeSlots() > 0){
			cards[cardsNumber] = device;
			cardsNumber ++;
			added = true;
		}
	}
	
	return added;
   } 

   public String toString(){
	String desc = super.toString() +" devices: [";
	
	for ( int i = 0 ; i<cardsNumber ; i++){
		desc += cards[i]+", ";
	}

	for( int i = 0; i < usbDevicesNumber ; i++){
		desc += usbDevices[i];
		if( i < usbDevicesNumber - 1 ){
			desc +=", ";
		}else{
			desc +="]";
		}
	}
  
	
	return desc;
   }
}
